commit 61f133f1042c8610647ae5a7e1ead59e0cad70f2
Author: Tamino Steinert <tamino.steinert@tamino.st>
Date:   Tue Oct 20 16:46:21 2020 +0200

    WebshopApi: Sprachdateien angepasst

diff --git a/js/locale/de.js b/js/locale/de.js
index 2423cf2b5..048dacacc 100644
--- a/js/locale/de.js
+++ b/js/locale/de.js
@@ -63,6 +63,7 @@ namespace("kivi").setupLocale({
 "File upload":"Datei Upload",
 "Function block actions":"Funktionsblockaktionen",
 "Generate and print sales delivery orders":"Erzeuge und drucke Lieferscheine",
+"Get one shoporder":"Hole eine Bestellung",
 "Hide all details":"Alle Details verbergen",
 "Hide details":"Details verbergen",
 "History":"Historie",
diff --git a/locale/de/all b/locale/de/all
index d05a790d4..f5e58fc33 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -895,6 +895,7 @@ $self->{texts} = {
   'Database Management'         => 'Datenbankadministration',
   'Database Superuser'          => 'Datenbank-Super-Benutzer',
   'Database User'               => 'Datenbankbenutzer',
+  'Database errors: #1'         => 'Datenbank-Fehler: #1',
   'Database host and port'      => 'Datenbankhost und -port',
   'Database login (#1)'         => 'Datenbankanmeldung (#1)',
   'Database name'               => 'Datenbankname',
@@ -1372,6 +1373,7 @@ $self->{texts} = {
   'Errors during conversion:'   => 'Umwandlungsfehler:',
   'Errors during printing:'     => 'Druckfehler:',
   'Errors in GL transaction:'   => 'Fehler in Dialogbuchung:',
+  'Errors: #1'                  => 'Fehler: #1',
   'Ertrag'                      => 'Ertrag',
   'Ertrag prozentual'           => 'Ertrag prozentual',
   'Escape character'            => 'Escape-Zeichen',
@@ -1434,6 +1436,7 @@ $self->{texts} = {
   'Feb'                         => 'Feb',
   'February'                    => 'Februar',
   'Fee'                         => 'Gebühr',
+  'Fetch order'                 => 'Hole Bestellung',
   'Field'                       => 'Feld',
   'File'                        => 'Datei',
   'File \'#1\' is used as new Version !' => 'Datei \'#1\' wird als neue Version verwendet!',
@@ -1506,6 +1509,7 @@ $self->{texts} = {
   'From Date'                   => 'Von',
   'From bin'                    => 'Ausgelagert',
   'From shop "#1" :  #2 '       => 'Shop #1 : #2',
+  'From shop "#1" :  Number: #2 #3 ' => 'Von Shop "#1" :  Nummer: #2 #3 ',
   'From shop #1 :  #2 shoporders have been fetched.' => 'Es wurden #2 Bestellungen von #1 geholt.',
   'From this version on a new feature is available.' => 'Ab dieser Version ist ein neues Feature verfügbar.',
   'From this version on it is necessary to name a default value.' => 'Ab dieser Version benötigt kivitendo eine Standardwährung.',
@@ -1540,6 +1544,9 @@ $self->{texts} = {
   'General settings'            => 'Allgemeine Einstellungen',
   'Generate and print sales delivery orders' => 'Erzeuge und drucke Lieferscheine',
   'Germany'                     => 'Deutschland',
+  'Get one order'               => 'Hole eine Bestellung',
+  'Get one order by shopordernumber' => 'Hole eine Bestellung über Shopbestellnummer',
+  'Get one shoporder'           => 'Hole eine Bestellung',
   'Get shoporders'              => 'Shopbestellungen holen und bearbeiten',
   'Git revision: #1, #2 #3'     => 'Git-Revision: #1, #2 #3',
   'Given Name'                  => 'Vorname',
@@ -2832,6 +2839,7 @@ $self->{texts} = {
   'Save proposals'              => 'Vorschläge speichern',
   'Save settings as'            => 'Einstellungen speichern unter',
   'Saving failed. Error message from the database: #1' => 'Speichern schlug fehl. Fehlermeldung der Datenbank: #1',
+  'Saving failed. Error message from the server: #1' => 'Speichern fehlgeschlagen. Fehlermeldung vom Server: #1',
   'Saving the file \'%s\' failed. OS error message: %s' => 'Das Speichern der Datei \'%s\' schlug fehl. Fehlermeldung des Betriebssystems: %s',
   'Saving the record template \'#1\' failed.' => 'Das Speichern der Belegvorlage »#1« schlug fehl.',
   'Score'                       => 'Punkte',
@@ -2943,6 +2951,7 @@ $self->{texts} = {
   'Shop Orders'                 => 'Shopaufträge',
   'Shop article'                => 'Shopartikel',
   'Shop customernumber'         => 'Shop - Kundennumer',
+  'Shop or ordernumber not selected.' => 'Shop oder Bestellnummer nicht ausgewählt',
   'Shop orderdate'              => 'Shopauftragsdatum',
   'Shop ordernumber'            => 'Shopauftragsnummer',
   'Shop part'                   => 'Shopartikel',
@@ -2954,6 +2963,7 @@ $self->{texts} = {
   'Shoporder'                   => 'Shopbestellung',
   'Shoporder deleted -- '       => 'ungültig',
   'Shoporder not found'         => 'Shopbestellung nicht gefunden',
+  'Shoporder with this ordernumber is already fetched' => 'Bestellung mit diese Bestellnummer wurde bereits geholt',
   'Shoporderlock'               => 'Shopauftragssperre',
   'Shoporders'                  => 'Shopbestellungen',
   'Shops'                       => 'Webshops',