commit 6b6ddadb68a57757e865985a2854310f8e26fe9e
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Mon Jul 29 17:36:04 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/requirement_spec/select_template_to_paste.html

diff --git a/templates/webpages/requirement_spec/select_template_to_paste.html b/templates/webpages/requirement_spec/select_template_to_paste.html
index 41117c95f..4051694b5 100644
--- a/templates/webpages/requirement_spec/select_template_to_paste.html
+++ b/templates/webpages/requirement_spec/select_template_to_paste.html
@@ -1,84 +1,86 @@
-[%- BLOCK text_blocks %]
- [%- IF blocks.size %]
-     <li>
-      [%- title %]:
 [% USE LxERP %]
 [% USE HTML %]
 [% USE L %]
+
+[% BLOCK text_blocks %]
+  [% IF blocks.size %]
+    <li>[% title %]:
       <ol>
-       [%- FOREACH block = blocks %]
-        <li>[%- HTML.escape(block.title) %]</li>
-       [%- END %]
+        [% FOREACH block = blocks %]
+          <li>[% HTML.escape(block.title) %]</li>
+        [% END %]
       </ol>
-     </li>
- [%- END %]
-[%- END %]
-
-[%- IF !TEMPLATES.size %]
-<p>[%- LxERP.t8("No requirement spec templates have been created yet.") %]</p>
+    </li>
+  [% END %]
+[% END %]
 
-[%- ELSE %]
+[% IF !TEMPLATES.size %]
+  <p>[% LxERP.t8("No requirement spec templates have been created yet.") %]</p>
 
-<table>
- <tr class="listheading">
-  <th>[%- LxERP.t8("Detail view") %]</th>
-  <th>[%- LxERP.t8("Paste template") %]</th>
-  <th>[%- LxERP.t8("Title") %]</th>
-  <th>[%- LxERP.t8("Type") %]</th>
-  <th>[%- LxERP.t8("Last modification") %]</th>
+[% ELSE %]
+<table class="tbl-list">
+  <thead>
+ <tr>
+  <th>[% LxERP.t8("Detail view") %]</th>
+  <th>[% LxERP.t8("Paste template") %]</th>
+  <th>[% LxERP.t8("Title") %]</th>
+  <th>[% LxERP.t8("Type") %]</th>
+  <th>[% LxERP.t8("Last modification") %]</th>
  </tr>
-
-[%- FOREACH template = TEMPLATES %]
+ </thead>
+<tbody>
+[% FOREACH template = TEMPLATES %]
  <tr class="listrow[% loop.count % 2 %]">
   <td>
-   <a href="#" onclick="$('#select-template-details-row-[% template.id %]').toggle(); $(this).find('span').toggle();">
+   <a href="#" onclick='$("#select-template-details-row-[% template.id %]").toggle(); $(this).find("span").toggle();'>
     <span>[+]</span>
     <span style="display: none;">[-]</span>
    </a>
   </td>
-  <td><a href="#" onclick="kivi.requirement_spec.paste_selected_template([% template.id %]);">[%- LxERP.t8("Paste template") %]</a></td>
-  <td>[%- HTML.escape(template.title) %]</td>
-  <td>[%- HTML.escape(template.type.description) %]</td>
+  <td><a href="#" onclick='kivi.requirement_spec.paste_selected_template([% template.id %]);'>[% LxERP.t8("Paste template") %]</a></td>
+  <td>[% HTML.escape(template.title) %]</td>
+  <td>[% HTML.escape(template.type.description) %]</td>
   <td>[% template.mtime ? template.mtime.to_kivitendo(precision='minute') : template.itime.to_kivitendo(precision='minute') %]</td>
  </tr>
 
- <tr class="listrow[% loop.count % 2 %]" style="display: none;" id="select-template-details-row-[% template.id %]">
+ <tr style="display: none;" id="select-template-details-row-[% template.id %]">
   [% SET front    = template.text_blocks_sorted(output_position=0) %]
   [% SET sections = template.sections_sorted %]
   [% SET back     = template.text_blocks_sorted(output_position=1) %]
   [% SET parts    = template.parts_sorted %]
   <td colspan="4">
-   [%- LxERP.t8("What this template contains") %]:<br>
+   [% LxERP.t8("What this template contains") %]:<br>
    <ul>
     [% PROCESS text_blocks blocks=front title=LxERP.t8("#1 text block(s) front", front.size) %]
 
-    [%- IF sections.size %]
-    <li>[%- LxERP.t8("#1 section(s)", sections.size) %]:
+    [% IF sections.size %]
+    <li>[% LxERP.t8("#1 section(s)", sections.size) %]:
      <ol>
-      [%- FOREACH section = sections %]
-       <li>[%- HTML.escape(section.fb_number) %]: [%- HTML.escape(section.title) %]</li>
-      [%- END %]
+      [% FOREACH section = sections %]
+       <li>[% HTML.escape(section.fb_number) %]: [% HTML.escape(section.title) %]</li>
+      [% END %]
      </ol>
     </li>
-    [%- END %]
+    [% END %]
 
     [% PROCESS text_blocks blocks=back  title=LxERP.t8("#1 text block(s) back",  back.size)  %]
 
-    [%- IF parts.size %]
-    <li>[%- LxERP.t8("#1 additional part(s)", parts.size) %]:
+    [% IF parts.size %]
+    <li>[% LxERP.t8("#1 additional part(s)", parts.size) %]:
      <ol>
-      [%- FOREACH part = parts %]
-       <li>[%- HTML.escape(part.part.description) %]: [%- HTML.escape(part.qty_as_number) %] [% HTML.escape(part.unit.name) %]</li>
-      [%- END %]
+      [% FOREACH part = parts %]
+       <li>[% HTML.escape(part.part.description) %]: [% HTML.escape(part.qty_as_number) %] [% HTML.escape(part.unit.name) %]</li>
+      [% END %]
      </ol>
     </li>
-    [%- END %]
+    [% END %]
    </ul>
   </td>
  </tr>
-[%- END %]
+[% END %]
+</tbody>
 </table>
 
-[%- END %]
+[% END %]
 
-<p><a href="#" onclick="$('#jqueryui_popup_dialog').dialog('close');">[%- LxERP.t8("Abort") %]</a></p>
+<p><a href="#" onclick='$("#jqueryui_popup_dialog").dialog("close");' class="button neutral">[% LxERP.t8("Abort") %]</a></p>